@echo off
echo SUBSCRIPTS TEST GROUP
copy nul prog.empty > nul

echo Non-numeric subscript
copy /y subscripts.1 prog.cob > nul
cobc -C -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if not errorlevel 1 goto err
diff subscripts.2 comp.out
if errorlevel 1 goto err

echo Subscript range check
copy /y subscripts.3 prog.cob > nul
cobc -C -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if not errorlevel 1 goto err
diff subscripts.4 comp.out
if errorlevel 1 goto err

echo Subscript out of bounds (1)
copy /y subscripts.5 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff subscripts.6 result
if errorlevel 1 goto err

echo Subscript out of bounds (2)
copy /y subscripts.7 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff subscripts.8 result
if errorlevel 1 goto err

echo Value of DEPENDING ON N out of bounds (lower)
copy /y subscripts.9 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff subscripts.10 result
if errorlevel 1 goto err

echo Value of DEPENDING ON N out of bounds (upper)
copy /y subscripts.11 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff subscripts.12 result
if errorlevel 1 goto err

echo Subscript bounds with ODO (lower)
copy /y subscripts.13 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > nul 2> comp.out
if not errorlevel 1 goto err
diff subscripts.14 comp.out
if errorlevel 1 goto err

echo Subscript bounds with ODO (upper)
copy /y subscripts.15 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if not errorlevel 1 goto err
diff subscripts.16 comp.out
if errorlevel 1 goto err

echo Subscript bounds with ODO
copy /y subscripts.17 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff subscripts.18 result
if errorlevel 1 goto err

echo Subscript by arithmetic expression
copy /y subscripts.19 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff prog.empty result
if errorlevel 1 goto err

echo SUBSCRIPTS TEST PASSED
del test.conf prog.* result comp.out
goto end

:err
	echo SUBSCRIPTS TEST FAILED
	pause
:end
